Name:           qtsoap
Version:        2.7
Release:        %mkrel 15
Summary:        The Simple Object Access Protocol Qt-based client side library
Group:          Development/C
License:        LGPLv2 with exceptions or GPLv3
URL:            http://qt.nokia.com/products/appdev/add-on-products/catalog/4/Utilities/qtsoap/
Source0:        http://get.qt.nokia.com/qt/solutions/lgpl/qtsoap-%{version}_1-opensource.tar.gz
Patch0:         qtsoap-2.7_1-opensource-install-pub-headers.patch
Patch1:         qtsoap-2.7_1-qt5-cleanups.patch

BuildRequires:  pkgconfig(QtCore)
BuildRequires:  pkgconfig(QtGui)
BuildRequires:  pkgconfig(QtNetwork)
BuildRequires:  pkgconfig(QtXml)

BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5Gui)
BuildRequires:  pkgconfig(Qt5Network)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5Xml)

%description
The SOAP (Simple Object Access Protocol) library uses the XML standard
for describing how to exchange messages. Its primary usage is to invoke web
services and get responses from Qt-based applications.

#------------------------------------------------
### Qt4

%define qtsoap_major  2
%define libqtsoap     %mklibname %{name} %{qtsoap_major}

%package -n     %{libqtsoap}
Summary:        The Simple Object Access Protocol Qt4-based client side library
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
Obsoletes:      %{name} < 2.7-10

%description -n %{libqtsoap}
The SOAP (Simple Object Access Protocol) library uses the XML standard
for describing how to exchange messages. Its primary usage is to invoke web
services and get responses from Qt-based applications.
This package is built against Qt4.

#------------------------------------------------

%define libqtsoap_devel %mklibname %{name} -d

%package -n     %{libqtsoap_devel}
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{libqtsoap} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       lib%{name}-devel = %{version}-%{release}
Obsoletes:      %{name}-devel < 2.7-10

%description -n %{libqtsoap_devel}
Development files for %{name}.

### End Qt4

#------------------------------------------------

### Qt5

%define qtsoap5_major 2
%define libqtsoap5    %mklibname %{name}5_ %{qtsoap5_major}

%package -n     %{libqtsoap5}
Summary:        The Simple Object Access Protocol Qt5-based client side library
Group:          System/Libraries
Provides:       %{name}5 = %{version}-%{release}

%description -n %{libqtsoap5}
The SOAP (Simple Object Access Protocol) library uses the XML standard
for describing how to exchange messages. Its primary usage is to invoke web
services and get responses from Qt-based applications.
This package is built against Qt5.

#------------------------------------------------

%define libqtsoap5_devel %mklibname %{name}5 -d

%package -n     %{libqtsoap5_devel}
Summary:        Development files for %{name}5
Group:          Development/C
Requires:       %{libqtsoap5} = %{version}-%{release}
Provides:       %{name}5-devel = %{version}-%{release}
Provides:       lib%{name}5-devel = %{version}-%{release}

%description -n %{libqtsoap5_devel}
Development files for %{name}5.

### End Qt5
#------------------------------------------------

%prep
%setup -q -c -n %{name}

# headers are not installed for shared library
%patch0 -p0 -b .install-pub-headers
# Fix build for qt5
%patch1 -p0 -b .qt5

sed -i 's:$$DESTDIR:%{_libdir}:g' qtsoap-%{version}_1-opensource/buildlib/buildlib.pro

cp -a qtsoap-%{version}_1-opensource qtsoap5-%{version}_1-opensource

%build
### Qt4 Build
pushd qtsoap-%{version}_1-opensource
# we want shared library
echo "SOLUTIONS_LIBRARY = yes" > config.pri
echo "QTSOAP_LIBNAME = \$\$qtLibraryTarget(qtsoap)" >> common.pri
echo "VERSION=%{version}" >> common.pri

%qmake_qt4 PREFIX=%{_prefix}
%make_build CXXFLAGS="%{optflags} -fPIC"
popd

### Qt5 Build
pushd qtsoap5-%{version}_1-opensource
# we want shared library
echo "SOLUTIONS_LIBRARY = yes" > config.pri
echo "QTSOAP_LIBNAME = \$\$qtLibraryTarget(qtsoap5)" >> common.pri
echo "VERSION=%{version}" >> common.pri

%qmake_qt5 PREFIX=%{_prefix}
%make_build CXXFLAGS="%{optflags} -fPIC -DQT_DISABLE_DEPRECATED_BEFORE=0x000000"
popd

%install
%make_install INSTALL_ROOT=%{buildroot} -C qtsoap-%{version}_1-opensource
%make_install INSTALL_ROOT=%{buildroot} -C qtsoap5-%{version}_1-opensource

# ensure .so files are executable (0755) for proper -debuginfo extraction
chmod 0755 %{buildroot}%{_qt4_libdir}/libqtsoap.so*
chmod 0755 %{buildroot}%{_qt5_libdir}/libqtsoap.so*

%files -n %{libqtsoap}
%doc qtsoap-%{version}_1-opensource/README.TXT
%license qtsoap-%{version}_1-opensource/LGPL_EXCEPTION.txt
%license qtsoap-%{version}_1-opensource/LICENSE.GPL3
%license qtsoap-%{version}_1-opensource/LICENSE.LGPL
%{_qt4_libdir}/libqtsoap.so.%{qtsoap_major}{,.*}

%files -n %{libqtsoap_devel}
%{_qt4_libdir}/libqtsoap.so
%{_qt4_includedir}/QtSoap/

%files -n %{libqtsoap5}
%doc qtsoap5-%{version}_1-opensource/README.TXT 
%license qtsoap5-%{version}_1-opensource/LGPL_EXCEPTION.txt
%license qtsoap5-%{version}_1-opensource/LICENSE.GPL3
%license qtsoap5-%{version}_1-opensource/LICENSE.LGPL
%{_qt5_libdir}/libqtsoap5.so.%{qtsoap5_major}{,.*}

%files -n %{libqtsoap5_devel}
%{_qt5_libdir}/libqtsoap5.so
%{_qt5_includedir}/QtSoap/


%changelog
* Thu Dec 17 2020 umeabot <umeabot> 2.7-15.mga8
+ Revision: 1659706
- Rebuild for new Qt5

* Sat Feb 15 2020 umeabot <umeabot> 2.7-14.mga8
+ Revision: 1527905
- Mageia 8 Mass Rebuild

* Fri Jul 26 2019 daviddavid <daviddavid> 2.7-13.mga8
+ Revision: 1424450
- rebuild for new Qt5 headers path

* Mon Apr 01 2019 umeabot <umeabot> 2.7-12.mga7
+ Revision: 1384528
- Qt5 Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 2.7-11.mga7
+ Revision: 1300728
- Mageia 7 Mass Rebuild

* Sun Oct 08 2017 daviddavid <daviddavid> 2.7-10.mga7
+ Revision: 1170111
- port to Qt5 (needed for new meshlab)

* Tue Feb 16 2016 umeabot <umeabot> 2.7-9.mga6
+ Revision: 962556
- Mageia 6 Mass Rebuild

* Wed Oct 21 2015 daviddavid <daviddavid> 2.7-8.mga6
+ Revision: 893985
- fix empty debugfiles (permissions of libraries must be 0755 instead of 0644)

* Wed Oct 15 2014 umeabot <umeabot> 2.7-7.mga5
+ Revision: 739199
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.7-6.mga5
+ Revision: 688560
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 2.7-5.mga4
+ Revision: 517906
- Mageia 4 Mass Rebuild

* Sun Jan 13 2013 umeabot <umeabot> 2.7-4.mga3
+ Revision: 380055
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jun 17 2012 shlomif <shlomif> 2.7-3.mga3
+ Revision: 261300
- Got to build + rpmlint fixes
- Imported from Fedora RawHide


* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Jul 14 2011 Jaroslav Reznik <jreznik@redhat.com> - 2.7-2
- libqtsoap library name

* Thu May 19 2011 Jaroslav Reznik <jreznik@redhat.com> - 2.7-1
- fix version

* Tue Oct 26 2010 Jaroslav Reznik <jreznik@redhat.com> - 1.7-1
- Initial spec file